/* Copyright (C) NHR@FAU, University Erlangen-Nuremberg.
 * All rights reserved.
 * Use of this source code is governed by a MIT-style
 * license that can be found in the LICENSE file.*/
#include <stdlib.h>

#include "matrix.h"
#include "solver.h"
#include "util.h"

void spMVM(Matrix* m, double* x, double* y)
{
    CG_UINT numRows = m->nr;
    CG_UINT* rowPtr = m->rowPtr;
    CG_UINT* colInd = m->colInd;
    CG_FLOAT* val   = m->val;

    for (size_t rowID = 0; rowID < numRows; rowID++) {
        CG_FLOAT tmp = y[rowID];

        // loop over all elements in row
        for (size_t rowEntry = rowPtr[rowID]; rowEntry < rowPtr[rowID + 1]; rowEntry++) {
            tmp += val[rowEntry] * x[colInd[rowEntry]];
        }

        y[rowID] = tmp;
    }
}
