/* Copyright (C)  NHR@FAU, University Erlangen-Nuremberg.
 * All rights reserved. This file is part of nusif-solver.
 * Use of this source code is governed by a MIT style
 * license that can be found in the LICENSE file. */
#ifndef __SOLVER_H_
#define __SOLVER_H_
#include "comm.h"
#include "matrix.h"
#include "parameter.h"
#include "util.h"

typedef struct {
    /* geometry and grid information */
    /* parameters */
    double eps, omega;
    int itermax;

    /* communication */
    Comm* comm;
} Solver;

void initSolver(Solver*, Parameter*);
void spMVM(Matrix* m, CG_FLOAT* x, CG_FLOAT* y);
#endif // __SOLVER_H_
